>From 9b40a4db5cb49cc458e6d76bf9a60c0a9b6fe0f5 Mon Sep 17 00:00:00 2001
From: Arnaud <arnaud.champion@devatom.fr>
Date: Tue, 19 Oct 2010 16:01:39 +0200
Subject: [PATCH] Add Visual Studio 2010 and MonoDevelop solutions
 Add examples "virCOnnectOpenAuth" for Visual Studio and MonoDevelop

---
 Libvirt.cs                 |  468 +++++++++++++++++++++++---------------------
 LibvirtBindings.csproj     |   63 ------
 LibvirtBindings.sln        |   20 --
 LibvirtError.cs            |   18 +-
 LibvirtTypes.cs            |  128 ++++++++++--
 Properties/AssemblyInfo.cs |   36 ----
 6 files changed, 358 insertions(+), 375 deletions(-)
 delete mode 100644 LibvirtBindings.csproj
 delete mode 100644 LibvirtBindings.sln
 delete mode 100644 Properties/AssemblyInfo.cs

diff --git a/Libvirt.cs b/Libvirt.cs
index 0a18328..dcba9b3 100644
--- a/Libvirt.cs
+++ b/Libvirt.cs
@@ -17,6 +17,18 @@ namespace LibvirtBindings
     public class libVirt
     {
         private const int MaxStringLength = 1024;
+#if WINDOWS
+        private const string LibvirtDllImportName = "libvirt-0.dll";
+        private const string StrDupDllImportName = "msvcrt.dll";
+        private const string StrDupEntryPoint = "_strdup";
+#else
+        private const string LibvirtDllImportName = "libvirt.so.0";
+        private const string StrDupDllImportName = "libc.so.6";
+        private const string StrDupEntryPoint = "strdup";
+#endif
+        [DllImport(StrDupDllImportName, EntryPoint = StrDupEntryPoint, CallingConvention=CallingConvention.Cdecl)]
+        public static extern IntPtr StrDup(IntPtr strSource);
+
 
         #region Connect
         /// <summary>
@@ -24,23 +36,23 @@ namespace LibvirtBindings
         /// </summary>
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <returns>0 in case of success or -1 in case of error.</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectClose(IntPtr conn);
         /// <summary>
         /// Provides capabilities of the hypervisor / driver.
         /// </summary>
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <returns>NULL in case of error, or an XML string defining the capabilities. The client must free the returned string after use.</returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virConnectGetCapabilities(IntPtr conn);
         /// <summary>
         /// This returns the system hostname on which the hypervisor is running (the result of the gethostname system call). If we are connected to a remote system, then this returns the hostname of the remote system.
         /// </summary>
         /// <param name="conn">pointer to a hypervisor connection</param>
         /// <returns>the hostname which must be freed by the caller, or NULL if there was an error.</returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virConnectGetHostname(IntPtr conn);
         /// <summary>
         /// Provides @libVer, which is the version of libvirt used by the daemon running on the @conn host
@@ -48,7 +60,7 @@ namespace LibvirtBindings
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <param name="libVer">returns the libvirt library version used on the connection (OUT)</param>
         /// <returns>-1 in case of failure, 0 otherwise, and values for @libVer have the format major * 1,000,000 + minor * 1,000 + release.</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectGetLibVersion(IntPtr conn, ref ulong libVer);
         /// <summary>
         /// Provides the maximum number of virtual CPUs supported for a guest VM of a specific type. The 'type' parameter here corresponds to the 'type' attribute in the domain element of the XML.
@@ -56,23 +68,23 @@ namespace LibvirtBindings
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <param name="type">value of the 'type' attribute in the domain element</param>
         /// <returns>the maximum of virtual CPU or -1 in case of error.</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectGetMaxVcpus(IntPtr conn, string type);
         /// <summary>
         /// Get the name of the Hypervisor software used.
         /// </summary>
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <returns>NULL in case of error, a static zero terminated string otherwise. See also: http://www.redhat.com/archives/libvir-list/2007-February/msg00096.html</returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virConnectGetType(IntPtr conn);
         /// <summary>
         /// This returns the Uri (name) of the hypervisor connection. Normally this is the same as or similar to the string passed to the virConnectOpen/virConnectOpenReadOnly call, but the driver may make the Uri canonical. If name == NULL was passed to virConnectOpen, then the driver will return a non-NULL Uri which can be used to connect to the same hypervisor later.
         /// </summary>
         /// <param name="conn">pointer to a hypervisor connection</param>
         /// <returns>the Uri string which must be freed by the caller, or NULL if there was an error.</returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virConnectGetURI(IntPtr conn);
         /// <summary>
         /// Get the version level of the Hypervisor running. This may work only with hypervisor call, i.e. with privileged access to the hypervisor, not with a Read-Only connection.
@@ -80,21 +92,21 @@ namespace LibvirtBindings
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <param name="hvVer">return value for the version of the running hypervisor (OUT)</param>
         /// <returns>-1 in case of error, 0 otherwise. if the version can't be extracted by lack of capacities returns 0 and @hvVer is 0, otherwise @hvVer value is major * 1,000,000 + minor * 1,000 + release</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectGetVersion(IntPtr conn, ref ulong hvVer);
         /// <summary>
         /// Determine if the connection to the hypervisor is encrypted
         /// </summary>
         /// <param name="conn">pointer to the connection object</param>
         /// <returns>1 if encrypted, 0 if not encrypted, -1 on error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectIsEncrypted(IntPtr conn);
         /// <summary>
         /// Determine if the connection to the hypervisor is secure A connection will be classed as secure if it is either encrypted, or running over a channel which is not exposed to eavesdropping (eg a UNIX domain socket, or pipe)
         /// </summary>
         /// <param name="conn">pointer to the connection object</param>
         /// <returns>1 if secure, 0 if secure, -1 on error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectIsSecure(IntPtr conn);
         /// <summary>
         /// list the defined but inactive domains, stores the pointers to the names in @names
@@ -103,7 +115,7 @@ namespace LibvirtBindings
         /// <param name="names">pointer to an array to store the names</param>
         /// <param name="maxnames">size of the array</param>
         /// <returns>the number of names provided in the array or -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         private static extern int virConnectListDefinedDomains(IntPtr conn, IntPtr names, int maxnames);
         /// <summary>
         /// list the defined but inactive domains, stores the pointers to the names in @names
@@ -128,7 +140,7 @@ namespace LibvirtBindings
         /// <param name="names">array to collect the list of names of interfaces</param>
         /// <param name="maxnames">size of @names</param>
         /// <returns>the number of interfaces found or -1 in case of error </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         private static extern int virConnectListDefinedInterfaces(IntPtr conn, IntPtr names, int maxnames);
         ///<summary>
         /// Collect the list of defined (inactive) physical host interfaces, and store their names in @names.
@@ -153,7 +165,7 @@ namespace LibvirtBindings
         /// <param name="names">pointer to an array to store the names</param>
         /// <param name="maxnames">size of the array</param>
         /// <returns>the number of names provided in the array or -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         private static extern int virConnectListDefinedNetworks(IntPtr conn, IntPtr names, int maxnames);
         /// <summary>
         /// list the inactive networks, stores the pointers to the names in @names
@@ -178,7 +190,7 @@ namespace LibvirtBindings
         /// <param name="names">array of char * to fill with pool names (allocated by caller)</param>
         /// <param name="maxnames">size of the names array</param>
         /// <returns>0 on success, -1 on error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         private static extern int virConnectListDefinedStoragePools(IntPtr conn, IntPtr names, int maxnames);
         /// <summary>
         /// Provides the list of names of inactive storage pools upto maxnames. If there are more than maxnames, the remaining names will be silently ignored.
@@ -203,7 +215,7 @@ namespace LibvirtBindings
         /// <param name="ids">array to collect the list of IDs of active domains</param>
         /// <param name="maxids">size of @ids</param>
         /// <returns>the number of domain found or -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectListDomains(IntPtr conn, int[] ids, int maxids);
         /// <summary>
         /// Collect the list of active physical host interfaces, and store their names in @names
@@ -212,7 +224,7 @@ namespace LibvirtBindings
         /// <param name="names">array to collect the list of names of interfaces</param>
         /// <param name="maxnames">size of @names</param>
         /// <returns>the number of interfaces found or -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         private static extern int virConnectListInterfaces(IntPtr conn, IntPtr names, int maxnames);
         /// <summary>
         /// Collect the list of active physical host interfaces, and store their names in @names
@@ -237,7 +249,7 @@ namespace LibvirtBindings
         /// <param name="names">array to collect the list of names of active networks</param>
         /// <param name="maxnames">size of @names</param>
         /// <returns>the number of networks found or -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         private static extern int virConnectListNetworks(IntPtr conn, IntPtr names, int maxnames);
         /// <summary>
         /// Collect the list of active networks, and store their names in @names
@@ -262,7 +274,7 @@ namespace LibvirtBindings
         /// <param name="uuids">Pointer to an array to store the UUIDs</param>
         /// <param name="maxuuids">size of the array.</param>
         /// <returns>the number of UUIDs provided in the array, or -1 on failure.</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         private static extern int virConnectListSecrets(IntPtr conn, IntPtr uuids, int maxuuids);
         /// <summary>
         /// List UUIDs of defined secrets, store pointers to names in uuids.
@@ -287,7 +299,7 @@ namespace LibvirtBindings
         /// <param name="names">array of char * to fill with pool names (allocated by caller)</param>
         /// <param name="maxnames">size of the names array</param>
         /// <returns>0 on success, -1 on error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         private static extern int virConnectListStoragePools(IntPtr conn, IntPtr names, int maxnames);
         /// <summary>
         /// Provides the list of names of active storage pools upto maxnames. If there are more than maxnames, the remaining names will be silently ignored.
@@ -310,70 +322,70 @@ namespace LibvirtBindings
         /// </summary>
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <returns>the number of domain found or -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectNumOfDefinedDomains(IntPtr conn);
         /// <summary>
         /// Provides the number of defined (inactive) interfaces on the physical host.
         /// </summary>
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <returns>the number of defined interface found or -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectNumOfDefinedInterfaces(IntPtr conn);
         /// <summary>
         /// Provides the number of inactive networks.
         /// </summary>
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <returns>the number of networks found or -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectNumOfDefinedNetworks(IntPtr conn);
         /// <summary>
         /// Provides the number of inactive storage pools
         /// </summary>
         /// <param name="conn">pointer to hypervisor connection</param>
         /// <returns>the number of pools found, or -1 on error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectNumOfDefinedStoragePools(IntPtr conn);
         /// <summary>
         /// Provides the number of active domains.
         /// </summary>
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <returns>the number of domain found or -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectNumOfDomains(IntPtr conn);
         /// <summary>
         /// Provides the number of active interfaces on the physical host.
         /// </summary>
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <returns>the number of active interfaces found or -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectNumOfInterfaces(IntPtr conn);
         /// <summary>
         /// Provides the number of active networks.
         /// </summary>
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <returns>the number of network found or -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectNumOfNetworks(IntPtr conn);
         /// <summary>
         /// Fetch number of currently defined secrets.
         /// </summary>
         /// <param name="conn">virConnect connection</param>
         /// <returns>the number currently defined secrets.</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectNumOfSecrets(IntPtr conn);
         /// <summary>
         /// Provides the number of active storage pools
         /// </summary>
         /// <param name="conn">pointer to hypervisor connection</param>
         /// <returns>the number of pools found, or -1 on error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectNumOfStoragePools(IntPtr conn);
         /// <summary>
         /// This function should be called first to get a connection to the Hypervisor and xen store
         /// </summary>
         /// <param name="name">Uri of the hypervisor</param>
         /// <returns>pointer to the connection</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virConnectOpen(string name);
 
         ///<summary>
@@ -383,22 +395,22 @@ namespace LibvirtBindings
         ///<param name="auth">Authenticate callback parameters</param>
         ///<param name="flags">Open flags</param>
         ///<returns>a pointer to the hypervisor connection or NULL in case of error URIs are documented at http://libvirt.org/uri.html </returns>
-        [DllImport("libvirt-0.dll")]
-        public static extern IntPtr virConnectOpenAuth(string name, [In] ref virConnectAuth auth, int flags);
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        public static extern IntPtr virConnectOpenAuth(string name, ref virConnectAuth auth, int flags);
 
         /// <summary>
         /// This function should be called first to get a restricted connection to the library functionalities. The set of APIs usable are then restricted on the available methods to control the domains. See virConnectOpen for notes about environment variables which can have an effect on opening drivers
         /// </summary>
         /// <param name="name">Uri of the hypervisor</param>
         /// <returns>a pointer to the hypervisor connection or NULL in case of error URIs are documented at http://libvirt.org/uri.html </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virConnectOpenReadOnly(string name);
         /// <summary>
         /// Increment the reference count on the connection. For each additional call to this method, there shall be a corresponding call to virConnectClose to release the reference count, once the caller no longer needs the reference to this object. This method is typically useful for applications where multiple threads are using a connection, and it is required that the connection remain open until all threads have finished using it. ie, each new thread using a connection would increment the reference count.
         /// </summary>
         /// <param name="conn">the connection to hold a reference on</param>
         /// <returns>0 in case of success, -1 in case of failure</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virConnectRef(IntPtr conn);
         #endregion
 
@@ -409,7 +421,7 @@ namespace LibvirtBindings
         /// <param name="domain">pointer to domain object</param>
         /// <param name="xml">pointer to XML description of one device</param>
         /// <returns>0 in case of success, -1 in case of failure.</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virDomainAttachDevice(IntPtr domain, string xml);
         /// <summary>
         /// Attach a virtual device to a domain, using the flags parameter to control how the device is attached. VIR_DOMAIN_DEVICE_MODIFY_CURRENT specifies that the device allocation is made based on current domain state. VIR_DOMAIN_DEVICE_MODIFY_LIVE specifies that the device shall be allocated to the active domain instance only and is not added to the persisted domain configuration. VIR_DOMAIN_DEVICE_MODIFY_CONFIG specifies that the device shall be allocated to the persisted domain configuration only. Note that the target hypervisor must return an error if unable to satisfy flags. E.g. the hypervisor driver will return failure if LIVE is specified but it only supports modifying the persisted device allocation.
@@ -418,7 +430,7 @@ namespace LibvirtBindings
         /// <param name="xml">pointer to XML description of one device</param>
         /// <param name="flags">an OR'ed set of virDomainDeviceModifyFlags</param>
         /// <returns>0 in case of success, -1 in case of failure.</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virDomainAttachDeviceFlags(IntPtr domain, string xml, uint flags);
 
         // TODO virDomainBlockPeek
@@ -431,7 +443,7 @@ namespace LibvirtBindings
         /// <param name="stats">block device stats (returned)</param>
         /// <param name="size">size of stats structure</param>
         /// <returns>0 in case of success or -1 in case of failure.</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virDomainBlockStats(IntPtr dom, string path, virDomainBlockStatsStruct stats, int size);
         /// <summary>
         /// This method will dump the core of a domain on a given file for analysis. Note that for remote Xen Daemon the file path will be interpreted in the remote host.
@@ -440,7 +452,7 @@ namespace LibvirtBindings
         /// <param name="to">path for the core file</param>
         /// <param name="flags">extra flags, currently unused</param>
         /// <returns>0 in case of success and -1 in case of failure.</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virDomainCoreDump(IntPtr domain, string to, int flags);
         /// <summary>
         /// Launch a defined domain. If the call succeed the domain moves from the defined to the running domains pools.
@@ -451,11 +463,11 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 in case of success, -1 in case of error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virDomainCreate(IntPtr domain);
         /// <summary>
         /// Launch a new guest domain, based on an XML description similar to the one returned by virDomainGetXMLDesc().
-        /// This function may requires privileged access to the hypervisor. The domain is not persistent,
+        /// This function may requires privileged access to the hypervisor. The domain is not persistent, 
         /// so its definition will disappear when it is destroyed, or if the host is restarted (see virDomainDefineXML() to define persistent domains).
         /// </summary>
         /// <param name="conn">
@@ -470,10 +482,10 @@ namespace LibvirtBindings
         /// <returns>
         /// A new domain object or NULL in case of failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virDomainCreateXML(IntPtr conn, string xmlDesc, uint flags);
         /// <summary>
-        /// Define a domain, but does not start it. This definition is persistent, until explicitly undefined with virDomainUndefine().
+        /// Define a domain, but does not start it. This definition is persistent, until explicitly undefined with virDomainUndefine(). 
         /// A previous definition for this domain would be overriden if it already exists.
         /// </summary>
         /// <param name="conn">
@@ -485,11 +497,11 @@ namespace LibvirtBindings
         /// <returns>
         /// NULL in case of error, a pointer to the domain otherwise.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virDomainDefineXML(IntPtr conn, string xml);
         /// <summary>
-        /// Destroy the domain object. The running instance is shutdown if not down already
-        /// and all resources used by it are given back to the hypervisor.
+        /// Destroy the domain object. The running instance is shutdown if not down already 
+        /// and all resources used by it are given back to the hypervisor. 
         /// This does not free the associated virDomainPtr object. This function may require privileged access
         /// </summary>
         /// <param name="domain">
@@ -498,7 +510,7 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 in case of success and -1 in case of failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virDomainDestroy(IntPtr domain);
         /// <summary>
         /// Destroy a virtual device attachment to backend.
@@ -512,7 +524,7 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 in case of success, -1 in case of failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virDomainDetachDevice(IntPtr domain, string xml);
         /// <summary>
         /// Detach a virtual device from a domain, using the flags parameter to control how the device is detached. VIR_DOMAIN_DEVICE_MODIFY_CURRENT specifies that the device allocation is removed based on current domain state. VIR_DOMAIN_DEVICE_MODIFY_LIVE specifies that the device shall be deallocated from the active domain instance only and is not from the persisted domain configuration. VIR_DOMAIN_DEVICE_MODIFY_CONFIG specifies that the device shall be deallocated from the persisted domain configuration only. Note that the target hypervisor must return an error if unable to satisfy flags. E.g. the hypervisor driver will return failure if LIVE is specified but it only supports removing the persisted device allocation.
@@ -521,7 +533,7 @@ namespace LibvirtBindings
         /// <param name="xml">pointer to XML description of one device</param>
         /// <param name="flags">an OR'ed set of virDomainDeviceModifyFlags</param>
         /// <returns>0 in case of success, -1 in case of failure.</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virDomainDetachDeviceFlags(IntPtr domain, string xml, uint flags);
         /// <summary>
         /// Free the domain object. The running instance is kept alive. The data structure is freed and should not be used thereafter.
@@ -532,7 +544,7 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 in case of success and -1 in case of failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virDomainFree(IntPtr domain);
         /// <summary>
         /// Provides a boolean value indicating whether the domain configured to be automatically started when the host machine boots.
@@ -546,12 +558,12 @@ namespace LibvirtBindings
         /// <returns>
         /// -1 in case of error, 0 in case of success.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virDomainGetAutostart(IntPtr domain, out int autostart);
         /// <summary>
-        /// Provides the connection pointer associated with a domain.
-        /// The reference counter on the connection is not increased by this call.
-        /// WARNING: When writing libvirt bindings in other languages, do not use this function.
+        /// Provides the connection pointer associated with a domain. 
+        /// The reference counter on the connection is not increased by this call. 
+        /// WARNING: When writing libvirt bindings in other languages, do not use this function. 
         /// Instead, store the connection and the domain object together.
         /// </summary>
         /// <param name="dom">
@@ -560,7 +572,7 @@ namespace LibvirtBindings
         /// <returns>
         /// The <see cref="IntPtr"/>or NULL in case of failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virDomainGetConnect(IntPtr dom);
         /// <summary>
         /// Get the hypervisor ID number for the domain.
@@ -571,10 +583,10 @@ namespace LibvirtBindings
         /// <returns>
         /// The domain ID number or (unsigned int) -1 in case of error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virDomainGetID(IntPtr domain);
         /// <summary>
-        /// Extract information about a domain. Note that if the connection used to get the domain is limited only a
+        /// Extract information about a domain. Note that if the connection used to get the domain is limited only a 
         /// partial set of the information can be extracted.
         /// </summary>
         /// <param name="domain">
